<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - FastForward vs recursive</title>
</head>


<body>

<h1>FastForward vs recursive</h1>

<hr />

<p>original state:</p>
<pre>
A - B - C - D - E - F    (master - some upstream branch)
     \
      X ---- Y ------ Z  (testbranch - some 'topic' branch
                                       with feature to be added)
</pre>

<hr />

<p>Fast-forward merge is possible ONLY if one of the branches has no commits
ahead of the other. For example, if the original state would be</p>
<pre>
A - B                    (master)
     \
      - X - Y - Z        (testbranch)
</pre>
<p>testbranch can be fast-forwarded to master with following result:</p>
<pre>
A - B - X - Y - Z        (master)
</pre>

<p>Fast-forward merges are also used on push, so when someone updates the remote
repository, we have to rebase.<br />
Original state can be</p>
<pre>
A - B - C - D            (master)
     \
      X - Y - Z          (testbranch)
</pre>
<p>so we will rebase our branch on a new base, the 'D' commit:</p>
<pre>
A - B - C - D            (master)
             \
              X - Y - Z  (testbranch)
</pre>
<p>and we can now do a fast-forward push:</p>
<pre>
A - B - C - D - X - Y - Z        (master)
</pre>

<hr />

<p>A classic merge (using merge commit) can be performed when there are commits in both branches
above the shared base ('B' commit in this case):</p>
<pre>
A - B - C - D - E - F - M - G - H  (master)
     \                 /
      X ---- Y ------ Z            (testbranch)
</pre>
<p>and forced non-fast-forward merge with --no-ff (where it would be possible to do fast-forward)
can look like:</p>
<pre>
A - B ----------------- M - C - D  (master)
     \                 /
      X ---- Y ------ Z            (testbranch)
</pre>

<hr />

<p>So - it's better to use fast-forward or classic recursive merge? Well, it depends. There's a one big difference;<br />
fast-forwarding actually moves commits from the other branch into current one, while recursive ONLY adds one merge commit with changes from the remote branch (= result of a tree merge).</p>

<p>Commits 'G','H' (and 'C','D' in the second example) are there to just ilustrate
that no commits were moved from the testbranch.</p>

<p>So fast-forward is good for end users, testers, to update their repo without custom changes, recursive merge is good for merging someone else's stuff to just say "this wasn't in the upstream, it comes from the ouside", so you can fix possible bugs in commits ahead of the merge commit (or tell the author to send a fixed version). It's useful for documentation purposes as well ("everything from this merge is from Alice") so you can easily delete all commits from one maintainer just by removing the merge commit.</p>

<hr />

</body>


</html>
